<app-main-drawer [title]="'Nouvel itinéraire.'">
    <div class="d-flex action-btn" style="width:95%;gap: 10px;justify-content: end;">
        <button class="noShadow" color="primary" [disabled]="!currentTrip || !currentTrip.ID" mat-mini-fab
            (click)="addNewTrip()">
            <mat-icon>add_location_alt</mat-icon>
        </button>

        <button class="noShadow" color="primary" mat-mini-fab (click)="saveConnection()">
            <mat-icon>save</mat-icon>
        </button>

    </div>
    <div class="bloc-content d-flex" style="margin-top: 20px;">
        <div class="bloc-edit w-20 h-full stick">
            <h2>Informations</h2>
            <h5>Dans cet espace, ajouter les arrets de vos ligne et configurer leur périodicité.</h5>

            <div class="form-content d-flex" style="gap: 20px;">
                <div class="b-left">
                    <div>
                        <mat-form-field appearance="outline">
                            <span matPrefix style="margin-right: 8px;">
                                <mat-icon fontSet="material-symbols-rounded">date_range</mat-icon>
                            </span>
                            <mat-label>Fréquence hebdomadaire</mat-label>
                            <mat-hint>Saisir la fréquence hebdomadaire</mat-hint>

                            <mat-select [(ngModel)]="selectedFrequence">
                                <mat-option *ngFor="let item of frequenceList" [value]="item.ID">{{ item.Name }}
                                </mat-option>

                            </mat-select>
                        </mat-form-field>
                    </div>
                    <div>
                        <mat-form-field appearance="outline">
                            <span matPrefix style="margin-right: 8px;">
                                <mat-icon fontSet="material-symbols-rounded">directions_bus</mat-icon>
                            </span>
                            <mat-label>Véhicule</mat-label>

                            <mat-select [(ngModel)]="selectedVehicle">
                                <mat-option *ngFor="let item of vehicleList" [value]="item.ID">{{ item.Matricule }} +
                                    ({{
                                    item.NbPlace }} places)
                                </mat-option>

                            </mat-select>
                        </mat-form-field>
                    </div>



                </div>
            </div>
        </div>
        <div class="d-flex d-column w-60 o-design" style="gap:20px;">
            <div class="d-flex" style="gap: 20px;justify-content: center;">
                <div class="bloc-edit" style="padding: 10px 50px;">

                    <h2>Configurer vos trajets.</h2>
                    <div class="d-flex" style="justify-content: space-between;">
                        <div>
                            <h5>Configurer vos trajets ici.</h5>

                        </div>
                    </div>
                    <!-- <div>
                        <mat-slide-toggle [disabled]="!currentTrip?.ListArrets?.length || lockTrajetConfiguration"
                            [(ngModel)]="isTerminus">
                            Terminus.
                        </mat-slide-toggle>
                    </div> -->

                    <div class="b-right d-flex" style="width:100%;min-height: 60%;">
                        <div class="d-flex d-column" style="width: 95%;padding-top: 10px;">
                            <ng-container *ngIf="currentTrip">
                                <ng-container *ngIf="editMode">
                                    <ng-container *ngTemplateOutlet="blocEditStop; context{ trip: currentTrip }">
                                    </ng-container>
                                </ng-container>

                                <ng-container *ngIf="!editMode">
                                    <ng-container *ngTemplateOutlet="blocDisplayStop; context{ trip: currentTrip }">
                                    </ng-container>
                                </ng-container>
                            </ng-container>

                        </div>



                    </div>
                    <div style="text-align: right;">
                        <button class="noShadow" color="primary" mat-mini-fab (click)="validateChangeOnTrip()">
                            <mat-icon fontSet="material-symbols-rounded">
                                {{ editMode ? "done" : "edit" }}
                            </mat-icon>
                        </button>
                    </div>
                </div>


            </div>
            <div style="border-top: 1px solid grey;"></div>
            <div>
                <h2>Tranches horaires des voyages de cet itinéraire.</h2>

                <div class="trip-list" *ngIf="connection?.Trips?.length">
                    <ul>
                        <ng-container *ngFor="let item of connection.Trips">
                            <li *ngIf="item.ID;" [ngClass]="{'dashed': currentTrip.ID == item.ID}">
                                <div class="d-flex">
                                    <div>
                                        <mat-icon fontSet="material-symbols-rounded">mode_of_travel</mat-icon>
                                        <span>
                                            {{ item.DepartureArret?.City?.CityValue.Label + " - " +
                                            item.TerminusArret?.City?.CityValue.Label }}
                                            <br>
                                            <!--  <ng-container *ngFor="let item of listArret">
                
                                                </ng-container> -->
                                        </span>
                                    </div>

                                    <div class="vertical-separator"></div>

                                    <div>
                                        <mat-icon fontSet="material-symbols-rounded">schedule</mat-icon>
                                        <span>
                                            {{ item.DepartureArret?.DepartureTime | date:'H:mm' }} -
                                            {{ item.TerminusArret?.ArrivalTime | date:'H:mm' }}
                                        </span>
                                    </div>
                                    <div class="vertical-separator"></div>

                                    <div>
                                        <mat-icon fontSet="material-symbols-rounded">payments</mat-icon>
                                        <span>
                                            {{
                                            getFullPriceTrip(item.ID, item.DepartureArret.ID,
                                            item.TerminusArret.ID) ?
                                            getFullPriceTrip(item.ID, item.DepartureArret.ID, item.TerminusArret.ID) +
                                            'Francs CFA'
                                            : 'Prix non défini.'
                                            }}
                                        </span>
                                    </div>
                                    <div class="vertical-separator"></div>

                                    <div>
                                        <mat-icon fontSet="material-symbols-rounded">person</mat-icon>
                                        <span> {{ connection?.Agent?.FirstName }} </span>
                                    </div>
                                </div>
                                <div class="d-flex">
                                    <div *ngIf="!getFullPriceTrip(item.ID, item.DepartureArret.ID,
                                    item.TerminusArret.ID)">
                                        <mat-icon fontSet="material-symbols-rounded" color="warn"
                                            matTooltip="Les prix pour ce voyage ne sont pas défini.">warning</mat-icon>
                                    </div>
                                    <button mat-icon-button (click)="openPriceDialog(item)">
                                        <mat-icon fontSet="material-symbols-rounded">Euro</mat-icon>
                                    </button>

                                    <button mat-icon-button (click)="setCurrentTrip(item.ID)">
                                        <mat-icon fontSet="material-symbols-rounded">edit</mat-icon>
                                    </button>

                                    <button mat-icon-button>
                                        <mat-icon fontSet="material-symbols-rounded">delete</mat-icon>
                                    </button>
                                </div>

                            </li>

                        </ng-container>

                    </ul>
                </div>
            </div>


        </div>

    </div>
</app-main-drawer>

<ng-template #blocEditStop let-trip="trip">
    <div *ngFor="let arret of trip.ListArrets" class="d-flex" style="gap: 10px;">
        <div>
            <app-city-input [cities]="citiesValues"
                [disabled]="!arret || disableCurrentArret || lockTrajetConfiguration" [citySelectedId]="arret.CityID"
                (citySelectedChange)="arret.CityID = $event" #cityInput>
            </app-city-input>
        </div>


        <mat-form-field style="width: 120px;" appearance="outline">
            <span matPrefix style="margin-right: 8px;">
                <mat-icon fontSet="material-symbols-rounded">update
                </mat-icon>
            </span>
            <mat-label>heure d'arrivée</mat-label>
            <input [disabled]="!trip?.ListArrets?.length || !currentArret || lockTrajetConfiguration"
                [(ngModel)]="arret.ArrivalTime" matTimepicker />
        </mat-form-field>

        <mat-form-field style="width: 120px;" appearance="outline">
            <span matPrefix style="margin-right: 8px;">
                <mat-icon fontSet="material-symbols-rounded">update
                </mat-icon>
            </span>
            <mat-label>heure de départ</mat-label>
            <input [disabled]="isTerminus || !currentArret || lockTrajetConfiguration" [(ngModel)]="arret.DepartureTime"
                matTimepicker />
        </mat-form-field>
        <div>
            <button (click)="removeStop(arret)" mat-icon-button>
                <mat-icon fontSet="material-symbols-rounded">do_not_disturb_on
                </mat-icon>
            </button>
        </div>
    </div>
    <div>
        <button (click)="addNewStop()" mat-flat-button color="primary">Ajouter un nouvel
            arrêt</button>
    </div>
</ng-template>

<ng-template #blocDisplayStop let-trip="trip">
    <div class="arret-bloc d-flex d-column" style="min-height: 70%;margin-top: 20px;gap:15px;">
        <ng-container *ngIf="trip && trip.ListArrets">
            <div *ngFor="let arret of trip.ListArrets; let isFirst=first;" class="d-flex arret-list-item"
                style="gap: 10px;">
                <ng-container *ngIf="arret && arret.CityID">
                    <div>
                        <mat-icon fontSet="material-symbols-rounded">circle</mat-icon>
                    </div>
                    <div class="mt-2 shorten">
                        <p>
                            {{ arret.City.CityValue.Label }}
                        </p>
                    </div>
                    <div class="mt-2">
                        {{ arret.ArrivalTime && isValidDate(arret.ArrivalTime) ? (arret.ArrivalTime |
                        date: 'HH:mm') : 'xxx' }} -
                        {{ arret.DepartureTime && isValidDate(arret.DepartureTime) ?
                        (arret.DepartureTime | date: 'HH:mm') : 'xxx' }}
                    </div>
                    <!-- <div style="margin-top: -9px;">
                        <button mat-icon-button (click)="editArret(arret)">
                            <mat-icon>
                                edit_location_alt
                            </mat-icon>
                        </button>
                    </div>
                    <div *ngIf="!isFirst" style="margin-top: -9px;">
                        <button mat-icon-button (click)="removeArret(arret)">
                            <mat-icon>delete</mat-icon>
                        </button>
                    </div> -->
                </ng-container>


            </div>
        </ng-container>


    </div>
</ng-template>